<h1>Binding</h1>

<div class="container">

  <button (click)="toggleForm()" class="btn btn-sm btn-info">Add Character</button>

  <div class="card card-body" *ngIf="showForm">
    <form #characterForm="ngForm" (ngSubmit)="onSubmit(characterForm)">

<!--      The variable characterForm in our template, will point to our
instance of the ngForm directive.
          One of the things the ngForm directive does is create a top-level
          FormGroup and lets us call functions as if it was an instance of a FormGroup-->
      <div class="form-group">
        <label>Persona:</label>
          <input
              type="text"
              [(ngModel)]="character.persona"
              [ngClass]="{'is-invalid': characterPersona.errors && characterPersona.touched}"
              name="persona"
              class="form-control"

              #characterPersona="ngModel"
              required
              minlength="2"
          >
<!--        special input #characterPersona =ngModel (shortcut for characterForm.persona)
            ngClass is-invalid (name of our class) .errors = if there's an error .touched = if user clicked it
-->
        <div [hidden]="!characterPersona.errors?.required" class="invalid-feedback">
          Persona name required
        </div>

        <div [hidden]="!characterPersona.errors?.minlength" class="invalid-feedback">
          Must be at least 2 characters
        </div>

        <label>First Name:</label>
          <input type="text" [(ngModel)]="character.firstName" name="firstName" class="form-control">

        <label>Last Name:</label>
          <input type="text" [(ngModel)]="character.lastName" name="lastName" class="form-control">

        <label>Age:</label>
          <input type="number" [(ngModel)]="character.age" name="age" class="form-control">

        <label>Address Street:</label>
          <input type="text" [(ngModel)]="character.address.street" name="street" class="form-control">

        <label>City:</label>
          <input type="text" [(ngModel)]="character.address.city" name="city" class="form-control">

        <label>State:</label>
          <input type="text" [(ngModel)]="character.address.state" name="state" class="form-control">
      </div>

      <button [disabled]="!characterForm.form.valid" class="btn btn-dark float-right">Add Character</button>

<!--      updated button
          if NOT character.form.valid ?
          button is disabled

          any rules / validations that we applied are not met,
          button will remain disabled -->
    </form>
  </div>

  <ul class="list-unstyled">
    <li class="card card-body mb-3" *ngFor="let character of characters" [class.bg-info]="character.isActive">

      <div class="row">

        <div class="col-sm-4">
          <img class="img-fluid" [src]="character.img" alt="">
        </div>

        <div class="col-sm-8">

          <h1 [ngStyle]="currentStyle">
            {{ character.persona | uppercase }}
            <button (click)="toggleInfo(character)" class="btn btn-outline-dark btn-sm ml-3">
              <i [ngClass]="character.hide ? 'fa fa-minus' : 'fa fa-plus'"></i>
            </button>
          </h1>

          <h3
            [ngStyle]="currentStyle"> {{ character.firstName }} {{ character.lastName }}
          </h3>

          <ul class="list-group" *ngIf="character.hide">
            <li class="list-group-item">Age: {{ character.age }} </li>
<!--            <li class="list-group-item">Address: {{ character.address.street }}, {{ character.address.city }}, {{ character.address.state }} </li>-->
            <li *ngIf="character.balance" class="list-group-item">Balance: {{ character.balance | currency:"JPY" }} </li>
            <li *ngIf="character.memberSince" class="list-group-item">Member Since: {{ character.memberSince | date:'MM/dd/yyyy' }} </li>
          </ul>

        </div>

      </div>

    </li>
  </ul>
</div>
